(function ($) {
  Drupal.behaviors.imagePart = {
    canvas:  {},
    image:   {},
    input:   {},
    polygon: {},
    unit:    {},
    attach: function (context, settings) {
        Drupal.behaviors.imagePart.input   = $('.canvas-area');
        Drupal.behaviors.imagePart.polygon = $('.polygon');

        Drupal.behaviors.imagePart.input.parent().on('DOMNodeInserted', function () {
            if ($.isEmptyObject(Drupal.behaviors.imagePart.image)) {
                var canvas = Drupal.behaviors.imagePart.input.parent().find('canvas');

                if ($.isEmptyObject(canvas)) {
                    return;
                }

                Drupal.behaviors.imagePart.canvas = canvas;

                Drupal.behaviors.imagePart.canvas.on('DOMSubtreeModified' ,function () {
                    if (!$.isEmptyObject(Drupal.behaviors.imagePart.image)) {
                        return;
                    }

                    var x = $(this).attr('width');
                    var y = $(this).attr('height');

                    if (!x || !y) {
                        return;
                    }

                    Drupal.behaviors.imagePart.image = { "x": x, "y": y };

                    Drupal.behaviors.imagePart.canvas.on('mouseout', function () {
                        Drupal.behaviors.imagePart.canvas.trigger('mouseup');
                    });
                });

                $(document).on('mouseup', function () {
                    Drupal.behaviors.imagePart.unit = $('.units').val();

                    var polygon = [];
                    var values  = Drupal.behaviors.imagePart.input.val();

                    $.each(values.split(","), function ( index, value ) {
                        if ('%' === Drupal.behaviors.imagePart.unit) {
                            var remainder = index % 2;
                            var coord     = (!remainder) ? 'x' : 'y';
                            var max       = Drupal.behaviors.imagePart.image[coord];
                            value         = Math.floor( value / max * 100 );
                        }

                        polygon.push(value + Drupal.behaviors.imagePart.unit);
                    });

                    Drupal.behaviors.imagePart.polygon.val(polygon.join(","));
                })
            }
        });
    }
  };
}(jQuery));